/* Definitions of target machine for GCC,
   for ARM with targeting the VXWorks 6 run time environment.
   Copyright (C) 1999-2014 Free Software Foundation, Inc.

   Contributed by: Mike Stump <mrs@wrs.com>
   Brought up to date by CodeSourcery, LLC.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Under Section 7 of GPL version 3, you are granted additional
permissions described in the GCC Runtime Library Exception, version
3.1, as published by the Free Software Foundation.

You should have received a copy of the GNU General Public License and
a copy of the GCC Runtime Library Exception along with this program;
see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
<http://www.gnu.org/licenses/>.  */

/* Setup to produce unwind info for DW2 eh and to
   configure crtstuff accordingly.  */

#include "vxworks.h"

#undef SUBTARGET_EXTRA_ASM_SPEC
#define SUBTARGET_EXTRA_ASM_SPEC VXWORKS_ENDIAN_SPEC

#undef TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()		\
  do {						\
    if (arm_arch7)				\
      {						\
       if (thumb_code)				\
	  builtin_define ("CPU=ARMARCH7_T2");   \
       else					\
	  builtin_define ("CPU=ARMARCH7");      \
      }						\
    else if (arm_arch_xscale)			\
      builtin_define ("CPU=XSCALE");		\
    else if (arm_arch5)				\
      builtin_define ("CPU=ARMARCH5");		\
    else if (arm_arch4)				\
      {						\
       if (thumb_code)				\
	  builtin_define ("CPU=ARMARCH4_T");	\
       else					\
	  builtin_define ("CPU=ARMARCH4");      \
      }						\
    VXWORKS_ARM_OS_CPP_BUILTINS();		\
  } while (false);

/* Subsume the arm/elf.h definition, and add RTP hooks.  */
#undef SUBTARGET_CPP_SPEC
#define SUBTARGET_CPP_SPEC "-D__ELF__" 			\
 "%{!nostdinc:						\
    %{isystem*}						\
    %{mrtp: -idirafter %:getenv(WIND_USR /h)		\
            -idirafter %:getenv(WIND_USR /h/wrn/coreip)	\
      ;:    -idirafter %:getenv(WIND_BASE /target/h)	\
            -idirafter %:getenv(WIND_BASE /target/h/wrn/coreip)}}"

#undef LIB_SPEC
#define LIB_SPEC VXWORKS_LIB_SPEC \
 "%{mrtp:%{!shared: \
    -L%:getenv(WIND_BASE /target/lib_smp/usr/lib/arm/ARMARCH7/common) \
 }}"



