/* Definitions of target machine for GCC,
   for ARM with targeting the VXWorks7 run time environment. 
   Copyright (C) 2014 Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Under Section 7 of GPL version 3, you are granted additional
permissions described in the GCC Runtime Library Exception, version
3.1, as published by the Free Software Foundation.

You should have received a copy of the GNU General Public License and
a copy of the GCC Runtime Library Exception along with this program;
see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
<http://www.gnu.org/licenses/>.  */

/* ARM for vx7 now uses ARM unwinding, not DW2 */
#undef  DWARF2_UNWIND_INFO
#define DWARF2_UNWIND_INFO 0

/* vxworks7 does not support .init_array and .fini_array elaboration
   mechanism, so we stick to the .ctor/.dtor mechanism from vx6 */
#undef CTOR_LIST_BEGIN
#undef CTOR_LIST_END
#undef DTOR_LIST_BEGIN
#undef DTOR_LIST_END
#undef CTORS_SECTION_ASM_OP
#define CTORS_SECTION_ASM_OP ARM_CTORS_SECTION_OP
#undef DTORS_SECTION_ASM_OP
#define DTORS_SECTION_ASM_OP ARM_DTORS_SECTION_OP

/* Use the proper elf abi to asm, together with vxworks endian spec.  */
#undef SUBTARGET_EXTRA_ASM_SPEC
#define SUBTARGET_EXTRA_ASM_SPEC		\
  "%{mabi=apcs-gnu|mabi=atpcs:-meabi=gnu;:-meabi=5}" TARGET_FIX_V4BX_SPEC \
  VXWORKS_ENDIAN_SPEC

/* Prevents the generation of .text.hot and .text.unlikely sections, as they
   badly interact with the exception unwinding in kernel mode.
   The arm-style exception unwinding requires only one .text section, which is
   normally the case for fully linked elf objects, but as vxw kernel objects
   are just partially linked, having several text sections makes all .text.*
   sections invisible to unwinding. */
#undef CC1_SPEC
#define CC1_SPEC "%(cc1_cpu) %{!mrtp:-fno-reorder-functions}"

#undef TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()     \
  do {				     \
    builtin_define ("CPU=ARMARCH7"); \
    VXWORKS_ARM_OS_CPP_BUILTINS ();  \
  } while (false)

#undef LIB_SPEC
#define LIB_SPEC VXWORKS_LIB_SPEC

#undef ARM_TARGET2_DWARF_FORMAT
#define ARM_TARGET2_DWARF_FORMAT (TARGET_VXWORKS_RTP ? DW_EH_PE_pcrel : DW_EH_PE_absptr)
