/* IA32 VxWorks7 target definitions for GNU compiler.
   Copyright (C) 2014
   Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#undef DEFAULT_CMODEL_64
#define DEFAULT_CMODEL_64 \
  (TARGET_VXWORKS_RTP ? flag_pic ? CM_LARGE_PIC : CM_LARGE : CM_LARGE)

/* ptrdiff and size_t already defined by x86-64.h, but wrongly overriden
   by config/vxworks.h. We need to redefine it here */
#undef PTRDIFF_TYPE
#define PTRDIFF_TYPE (TARGET_LP64 ? "long int" : "int")
#undef SIZE_TYPE
#define SIZE_TYPE (TARGET_LP64 ? "long unsigned int" : "unsigned int")

#if TARGET_64BIT_DEFAULT
#define SPEC_32 "m32"
#define SPEC_64 "m32:;"
#else
#define SPEC_32 "m64:;"
#define SPEC_64 "m64"
#endif

#undef  ASM_SPEC
#define ASM_SPEC "%{" SPEC_32 ":--32} %{" SPEC_64 ":--64}"

#undef  CPP_SPEC
#define CPP_SPEC VXWORKS_ADDITIONAL_CPP_SPEC
#undef  LIB_SPEC
#define LIB_SPEC VXWORKS_LIB_SPEC

/* X86 uses a different rtp base address */
#undef  STARTFILE_SPEC
#define STARTFILE_SPEC "%{mrtp:%{!shared:" \
  "%{" SPEC_32 ": --defsym=__wrs_rtp_base=0x68000000} " \
  "%{" SPEC_64 ": --defsym=__wrs_rtp_base=0x200000} " \
  "-l:crt0.o}}"

#if TARGET_64BIT_DEFAULT
/* On 64-bit target, we need more room for unwinding stack
   overflows. */
#undef STACK_CHECK_PROTECT
#define STACK_CHECK_PROTECT (16 * 1024)
#endif
