/* Copyright (C) 2002-2016 Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 3, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

Under Section 7 of GPL version 3, you are granted additional
permissions described in the GCC Runtime Library Exception, version
3.1, as published by the Free Software Foundation.

You should have received a copy of the GNU General Public License and
a copy of the GCC Runtime Library Exception along with this program;
see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
<http://www.gnu.org/licenses/>.  */

/* Common VxWorks headers inclusion sequence for the vxlib part of
   libgcc.  */

/* The apparent complexity with pre-inclusions and GCC #defines is
   there to worakround the fact that:

   * Both VxWorks and GCC have regs.h and version.h headers,

   * Other VxWorks header files #include them willing to get the
     VxWorks variant, and:
   
   * In absence of specific actions, our build setup for GCC would end
     up including the GCC variant instead, causing lots of errors.

   The trick we use here consists in:

   * Forcing the inclusion of the VxWorks variants thanks to
     #include directives from here with VxWorks path prefixes

   * Disabling the effect of later indirect inclusions of the gcc
     variants, which we don't need at all, thanks to local #defines
     pretending that the headers have already been included.  */

#include <vxWorks.h>
#ifndef __RTP__
#include <vxLib.h>
#ifdef _VSB_CONFIG_FILE /* Vxworks 7 */
#include <../public/version.h>
#include <../public/regs.h>
#else
#include <../h/version.h>
#include <../h/regs.h>
#endif
#endif
#define GCC_VERSION_H
#define GCC_REGS_H
#include <taskLib.h>
#ifndef __RTP__
#include <taskHookLib.h>
#else
#include <errno.h>
#endif
